diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/player.h freeciv-patched/common/player.h
--- freeciv-cvs/common/player.h	2003-06-30 12:18:29.000000000 +0100
+++ freeciv-patched/common/player.h	2003-06-30 12:18:10.000000000 +0100
@@ -205,6 +205,13 @@
   Impr_Status improvements[B_LAST]; /* improvements with equiv_range==Player */
   Impr_Status *island_improv; /* improvements with equiv_range==Island, dimensioned to
 			 	 [map.num_continents][game.num_impr_types] */
+  struct geff_vector effects;          /* effects with range==Player */
+  struct geff_vector *island_effects;  /* effects with range==Island */
+  struct ceff_vector destroyed_effects;/* list of effects that have survived
+					* building destruction */
+
+  /* Bonuses that affect all cities */
+  int science_bonus, tax_bonus;
 
   struct {
     int length;
@@ -233,7 +240,6 @@
 bool player_in_city_radius(struct player *pplayer, int x, int y);
 bool player_owns_active_wonder(struct player *pplayer,
 			      Impr_Type_id id);
-bool player_owns_active_govchange_wonder(struct player *pplayer);
 bool player_knows_improvement_tech(struct player *pplayer,
 				   Impr_Type_id id);
 bool player_knows_techs_with_flag(struct player *pplayer,
@@ -269,6 +275,7 @@
 bool is_barbarian(const struct player *pplayer);
 
 bool gives_shared_vision(struct player *me, struct player *them);
+void player_update_global_effects(struct player *pplayer);
 
 #define players_iterate(PI_player)                                            \
 {                                                                             \
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/tech.c freeciv-patched/common/tech.c
--- freeciv-cvs/common/tech.c	2003-06-30 12:18:29.000000000 +0100
+++ freeciv-patched/common/tech.c	2003-06-30 12:18:10.000000000 +0100
@@ -22,6 +22,7 @@
 
 #include "fcintl.h"
 #include "game.h"
+#include "log.h"
 #include "player.h"
 #include "shared.h" /* ARRAY_SIZE */
 #include "support.h"
@@ -66,7 +67,7 @@
 
   if (value == TECH_KNOWN) {
     game.global_advances[tech]++;
-    improvements_update_obsolete();
+    update_all_effects();
   }
 }
 
@@ -327,18 +328,33 @@
 }
 
 /**************************************************************************
- Returns number of turns to advance (assuming current state of
- civilization).
+ Returns the total number of bulbs the civilization produces every turn
 **************************************************************************/
-int tech_turns_to_advance(struct player *pplayer)
+int total_science_output(struct player *pplayer)
 {
-  /* The number of bulbs the civilization produces every turn. */
   int current_output = 0;
 
   city_list_iterate(pplayer->cities, pcity) {
     current_output += pcity->science_total;
   } city_list_iterate_end;
 
+  freelog(LOG_DEBUG, "Total science output: %d", current_output);
+  current_output = current_output * pplayer->science_bonus / 100;
+  current_output = current_output * game.science_bonus / 100;
+  freelog(LOG_DEBUG, "Player bonus %d; game bonus %d; total %d",
+	  pplayer->science_bonus, game.science_bonus, current_output);
+
+  return current_output;
+}
+
+/**************************************************************************
+ Returns number of turns to advance (assuming current state of
+ civilization).
+**************************************************************************/
+int tech_turns_to_advance(struct player *pplayer)
+{
+  int current_output = total_science_output(pplayer);
+
   if (current_output <= 0) {
     return FC_INFINITY;
   }
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/tech.h freeciv-patched/common/tech.h
--- freeciv-cvs/common/tech.h	2003-06-30 12:18:24.000000000 +0100
+++ freeciv-patched/common/tech.h	2003-06-30 12:18:10.000000000 +0100
@@ -119,6 +119,7 @@
 enum tech_flag_id tech_flag_from_str(const char *s);
 Tech_Type_id find_tech_by_flag(int index, enum tech_flag_id flag);
 
+int total_science_output(struct player *pplayer);
 int tech_turns_to_advance(struct player *pplayer);
 
 int total_bulbs_required(struct player *pplayer);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/unit.c freeciv-patched/common/unit.c
--- freeciv-cvs/common/unit.c	2003-06-30 12:18:28.000000000 +0100
+++ freeciv-patched/common/unit.c	2003-06-30 12:18:17.000000000 +0100
@@ -38,9 +38,6 @@
 This function calculates the move rate of the unit taking into 
 account the penalty for reduced hitpoints (affects sea and land 
 units only) and the effects of wonders for sea units. 
-
-FIXME: Use generalised improvements code instead of hardcoded
-wonder effects --RK
 ***************************************************************/
 int unit_move_rate(struct unit *punit)
 {
@@ -49,20 +46,13 @@
   switch (unit_type(punit)->move_type) {
   case LAND_MOVING:
     move_rate = (move_rate * punit->hp) / unit_type(punit)->hp;
+    move_rate += punit->move_modifier;
     break;
  
   case SEA_MOVING:
     move_rate = (move_rate * punit->hp) / unit_type(punit)->hp;
+    move_rate += punit->move_modifier;
 
-    if (player_owns_active_wonder(unit_owner(punit), B_LIGHTHOUSE)) {
-      move_rate += SINGLE_MOVE;
-    }
- 
-    if (player_owns_active_wonder(unit_owner(punit), B_MAGELLAN)) {
-      move_rate += (improvement_variant(B_MAGELLAN) == 1) 
-                     ? SINGLE_MOVE : 2 * SINGLE_MOVE;
-    }
- 
     if (player_knows_techs_with_flag(unit_owner(punit), TF_BOAT_FAST)) {
       move_rate += SINGLE_MOVE;
     }
@@ -74,6 +64,7 @@
 
   case HELI_MOVING:
   case AIR_MOVING:
+    move_rate += punit->move_modifier;
     break;
 
   default:
@@ -210,15 +201,19 @@
 **************************************************************************/
 bool unit_can_help_build_wonder(struct unit *punit, struct city *pcity)
 {
+  int imp_value;
+
   if (!is_tiles_adjacent(punit->x, punit->y, pcity->x, pcity->y)
       && !same_pos(punit->x, punit->y, pcity->x, pcity->y))
     return FALSE;
 
+  imp_value = improvement_value_adjusted(pcity->currently_building, pcity);
+
   return unit_flag(punit, F_HELP_WONDER)
          && punit->owner == pcity->owner
          && !pcity->is_building_unit
          && is_wonder(pcity->currently_building)
-         && pcity->shield_stock < improvement_value(pcity->currently_building);
+         && pcity->shield_stock < imp_value;
 }
 
 
@@ -411,6 +406,14 @@
 /**************************************************************************
 ...
 **************************************************************************/
+void get_unit_classes(struct unit *punit, struct unit_classes *classes)
+{
+  get_unittype_classes(punit->type, classes);
+}
+
+/**************************************************************************
+...
+**************************************************************************/
 bool kills_citizen_after_attack(struct unit *punit)
 {
   return TEST_BIT(game.killcitizen, (int) (unit_type(punit)->move_type) - 1);
@@ -476,14 +479,8 @@
     return AB_TOO_BIG;
   if (pcity->owner != punit->owner)
     return AB_NOT_OWNER;
-  if (improvement_exists(B_AQUEDUCT)
-      && !city_got_building(pcity, B_AQUEDUCT)
-      && new_pop > game.aqueduct_size)
+  if (pcity->size_limit >= 0 && new_pop > pcity->size_limit)
     return AB_NO_AQUEDUCT;
-  if (improvement_exists(B_SEWER)
-      && !city_got_building(pcity, B_SEWER)
-      && new_pop > game.sewer_size)
-    return AB_NO_SEWER;
   return AB_ADD_OK;
 }
 
@@ -1329,9 +1326,9 @@
 }
 
 /**************************************************************************
-  Like base_trireme_loss_pct but take the position into account.
+  Like base_ship_loss_pct but take the position into account.
 **************************************************************************/
-int trireme_loss_pct(struct player *pplayer, int x, int y)
+int ship_loss_pct(struct unit *punit, int x, int y)
 {
   /*
    * If we are in a city or next to land, we have no chance of losing
@@ -1339,28 +1336,46 @@
    * we'd need to confirm that we can exist/move at the (x, y)
    * location we are given.
    */
-  if (map_get_terrain(x, y) != T_OCEAN || is_coastline(x, y)) {
+  if (!unit_flag(punit, F_TRIREME) || map_get_terrain(x, y) != T_OCEAN
+      || is_coastline(x, y)) {
     return 0;
   } else {
-    return base_trireme_loss_pct(pplayer);
+    struct map_position mp;
+    mp.x = x;
+    mp.y = y;
+    return base_ship_loss_pct(punit, &mp);
   }
 }
 
 /**************************************************************************
  Triremes have a varying loss percentage. based on tech. Seafaring
- reduces this to 25%, Navigation to 12.5%. The Lighthouse wonder
- reduces this to 0.
+ reduces this to 25%, Navigation to 12.5%. The No_Sink_Deep improvement
+ effect (e.g. Lighthouse wonder) reduces this to 0. (Units that are not
+ Triremes always have a loss percentage of 0.)
+ mp should point to a map position, or be NULL if this is indeterminate.
 **************************************************************************/
-int base_trireme_loss_pct(struct player *pplayer)
+int base_ship_loss_pct(struct unit *punit, struct map_position *mp)
 {
-  if (player_owns_active_wonder(pplayer, B_LIGHTHOUSE)) {
+  struct player *pplayer = unit_owner(punit);
+
+  if (!unit_flag(punit, F_TRIREME)) {
     return 0;
-  } else if (player_knows_techs_with_flag(pplayer, TF_REDUCE_TRIREME_LOSS2)) {
-    return 12;
-  } else if (player_knows_techs_with_flag(pplayer, TF_REDUCE_TRIREME_LOSS1)) {
-    return 25;
   } else {
-    return 50;
+    struct eff_iter iter;
+    int losspct = 50;
+    if (player_knows_techs_with_flag(pplayer, TF_REDUCE_TRIREME_LOSS1)) {
+      losspct = 25;
+    }
+    if (player_knows_techs_with_flag(pplayer, TF_REDUCE_TRIREME_LOSS2)) {
+      losspct = 12;
+    }
+    eff_iterator_unit_init(&iter, punit->type, punit->type, pplayer, mp);
+    while (eff_iterator_next(&iter)) {
+      if (iter.imeff->type == EFT_NO_SINK_DEEP) {
+        return 0;
+      }
+    }
+    return losspct;
   }
 }
 
@@ -1438,7 +1453,10 @@
   punit->foul = FALSE;
   punit->fuel = unit_type(punit)->fuel;
   punit->hp = unit_type(punit)->hp;
+  punit->move_modifier = 0;
+  punit->hp_recover = 0;
   punit->moves_left = unit_move_rate(punit);
+
   punit->moved = FALSE;
   punit->paradropped = FALSE;
   punit->connecting = FALSE;
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/unit.h freeciv-patched/common/unit.h
--- freeciv-cvs/common/unit.h	2003-06-30 12:18:28.000000000 +0100
+++ freeciv-patched/common/unit.h	2003-06-30 12:17:55.000000000 +0100
@@ -126,6 +126,8 @@
   int goto_dest_x, goto_dest_y;
   int activity_count;
   enum tile_special_type activity_target;
+  int hp_recover;    /* hp to recover each turn (if -1, full recover) */
+  int move_modifier; /* moves bonus from Lighthouse, Magellan etc. */
   enum unit_focus_status focus_status;
   int ord_map, ord_city;
   /* ord_map and ord_city are the order index of this unit in tile.units
@@ -216,6 +218,7 @@
 bool is_air_unit(struct unit *punit);
 bool is_heli_unit(struct unit *punit);
 bool is_ground_unit(struct unit *punit);
+void get_unit_classes(struct unit *punit, struct unit_classes *classes);
 bool can_unit_add_to_city (struct unit *punit);
 bool can_unit_build_city (struct unit *punit);
 bool can_unit_add_or_build_city (struct unit *punit);
@@ -243,8 +246,8 @@
 struct unit *is_non_attack_unit_tile(struct tile *ptile,
 				     struct player *pplayer);
 
-int trireme_loss_pct(struct player *pplayer, int x, int y);
-int base_trireme_loss_pct(struct player *pplayer);
+int ship_loss_pct(struct unit *punit, int x, int y);
+int base_ship_loss_pct(struct unit *punit, struct map_position *mp);
 
 bool is_my_zoc(struct player *unit_owner, int x0, int y0);
 bool unit_being_aggressive(struct unit *punit);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/unittype.c freeciv-patched/common/unittype.c
--- freeciv-cvs/common/unittype.c	2003-06-30 12:18:28.000000000 +0100
+++ freeciv-patched/common/unittype.c	2003-06-30 12:18:17.000000000 +0100
@@ -39,10 +39,10 @@
 static const char *move_type_names[] = {
   "Land", "Sea", "Heli", "Air"
 };
-static const char *flag_names[] = {
+static char flag_names[F_MAX][MAX_LEN_NAME] = {
   "TradeRoute" ,"HelpWonder", "Missile", "IgZOC", "NonMil", "IgTer", 
-  "Carrier", "OneAttack", "Pikemen", "Horse", "IgWall", "FieldUnit", 
-  "AEGIS", "Fighter", "Marines", "Partial_Invis", "Settlers", "Diplomat",
+  "Carrier", "OneAttack", "(unused)", "(unused)", "IgWall", "FieldUnit", 
+  "(unused)", "Fighter", "Marines", "Partial_Invis", "Settlers", "Diplomat",
   "Trireme", "Nuclear", "Spy", "Transform", "Paratroopers",
   "Airbase", "Cities", "IgTired", "Missile_Carrier", "No_Land_Attack",
   "AddToCity", "Fanatic"
@@ -54,14 +54,6 @@
   "BarbarianBuild", "BarbarianBuildTech", "BarbarianLeader",
   "BarbarianSea", "BarbarianSeaTech"
 };
-static const char *unit_class_names[] = {
-  "Air",
-  "Helicopter",
-  "Land",
-  "Missile",
-  "Nuclear",
-  "Sea"
-};
 
 /**************************************************************************
 Returns 1 if the unit_type "exists" in this game, 0 otherwise.
@@ -130,6 +122,39 @@
 /**************************************************************************
 ...
 **************************************************************************/
+void get_unittype_classes(Unit_Type_id id, struct unit_classes *classes)
+{
+  struct unit_type *ut = get_unit_type(id);
+
+  classes->move_type = ut->move_type;
+  classes->flags = ut->flags;
+}
+
+/**************************************************************************
+...
+**************************************************************************/
+bool is_unit_class_in_set(Unit_Class_id id, struct unit_classes *classes)
+{
+  assert (id >= 0 && id <= UCL_LAST);
+
+  if (id == UCL_LAST || !classes || classes->move_type == LAST_MOVING) {
+    return TRUE;
+  } else if (id < F_MAX) {
+    return BV_ISSET(classes->flags, id);
+  } else {
+    if (id - F_MAX == AIR_MOVING
+	&& (BV_ISSET(classes->flags, F_NUCLEAR)
+            || BV_ISSET(classes->flags, F_MISSILE))) {
+      return FALSE;
+    } else {
+      return (classes->move_type == (id - F_MAX));
+    }
+  }
+}
+
+/**************************************************************************
+...
+**************************************************************************/
 int utype_shield_cost(struct unit_type *ut, struct government *g)
 {
   if (government_has_flag(g, G_FANATIC_TROOPS) &&
@@ -168,7 +193,7 @@
 **************************************************************************/
 bool unit_type_flag(Unit_Type_id id, int flag)
 {
-  assert(flag>=0 && flag<F_LAST);
+  assert(flag>=0 && flag<game.num_unit_flags);
   return BV_ISSET(unit_types[id].flags, flag);
 }
 
@@ -198,6 +223,25 @@
 }
 
 /**************************************************************************
+  Returns the effective value of the unit, after applying any
+  cost modifiers.
+**************************************************************************/
+int unit_value_adjusted(Unit_Type_id id, struct city *pcity)
+{
+  int i, val;
+  struct unit_classes aff_unit;
+
+  get_unittype_classes(id, &aff_unit);
+  val = unit_value(id);
+  for (i = 0; i <= UCL_LAST; ++i) {
+    if (is_unit_class_in_set(i, &aff_unit)) {
+      val = val * pcity->unit_cost_pct[i] / 100;
+    }
+  }
+  return val;
+}
+
+/**************************************************************************
 ...
 **************************************************************************/
 int unit_pop_value(Unit_Type_id id)
@@ -235,18 +279,6 @@
 }
 
 /**************************************************************************
-...
-**************************************************************************/
-const char *unit_class_name(Unit_Class_id id)
-{
-  if ((id >= 0) && (id < UCL_LAST)) {
-    return unit_class_names[id];
-  } else {
-    return "";
-  }
-}
-
-/**************************************************************************
  Return a string with all the names of units with this flag
  Return NULL if no unit with this flag exists.
  The string must be free'd
@@ -298,15 +330,22 @@
 /**************************************************************************
 ...
 **************************************************************************/
-int can_upgrade_unittype(struct player *pplayer, Unit_Type_id id)
+int can_upgrade_unittype(struct player *pplayer, Unit_Type_id id, bool leap)
 {
   Unit_Type_id best_upgrade = -1;
 
   if (!can_player_build_unit_direct(pplayer, id))
     return -1;
-  while (unit_type_exists(id = unit_types[id].obsoleted_by))
+
+  if (leap) {
+    while (unit_type_exists(id = unit_types[id].obsoleted_by))
+      if (can_player_build_unit_direct(pplayer, id))
+        best_upgrade = id;
+  } else {
+    id = unit_types[id].obsoleted_by;
     if (can_player_build_unit_direct(pplayer, id))
       best_upgrade = id;
+  }
 
   return best_upgrade;
 }
@@ -359,39 +398,30 @@
 }
 
 /**************************************************************************
-  Convert Unit_Class_id names to enum; case insensitive;
-  returns UCL_LAST if can't match.
-**************************************************************************/
-Unit_Class_id unit_class_from_str(const char *s)
-{
-  Unit_Class_id i;
-
-  assert(ARRAY_SIZE(unit_class_names) == UCL_LAST);
-
-  for (i = 0; i < UCL_LAST; i++) {
-    if (mystrcasecmp(unit_class_names[i], s)==0) {
-      return i;
-    }
-  }
-  return UCL_LAST;
-}
-
-/**************************************************************************
   Convert flag names to enum; case insensitive;
-  returns F_LAST if can't match.
+  returns F_MAX if can't match.
 **************************************************************************/
 enum unit_flag_id unit_flag_from_str(const char *s)
 {
   enum unit_flag_id i;
 
-  assert(ARRAY_SIZE(flag_names) == F_LAST);
+  assert(ARRAY_SIZE(flag_names) == F_MAX);
   
-  for(i=0; i<F_LAST; i++) {
+  for(i = 0; i < game.num_unit_flags; ++i) {
     if (mystrcasecmp(flag_names[i], s)==0) {
       return i;
     }
   }
-  return F_LAST;
+  return F_MAX;
+}
+
+/**************************************************************************
+  Set the name of one of the user-specified unit flags
+**************************************************************************/
+void unit_flag_set_name(enum unit_flag_id id, const char *s)
+{
+  assert(id >= F_LAST && id < game.num_unit_flags && id < F_MAX);
+  sz_strlcpy(flag_names[id], s);
 }
 
 /**************************************************************************
@@ -414,8 +444,8 @@
 
 /**************************************************************************
 Whether player can build given unit somewhere,
-ignoring whether unit is obsolete and assuming the
-player has a coastal city.
+ignoring whether unit is obsolete, any special requirements (e.g. for
+nuclear units) and assuming the player has a coastal city.
 **************************************************************************/
 bool can_player_build_unit_direct(struct player *p, Unit_Type_id id)
 {
@@ -424,8 +454,6 @@
 
   if (!unit_type_exists(id))
     return FALSE;
-  if (unit_type_flag(id, F_NUCLEAR) && game.global_wonders[B_MANHATTEN] == 0)
-    return FALSE;
   if (unit_type_flag(id, F_FANATIC)
       && !government_has_flag(get_gov_pplayer(p), G_FANATIC_TROOPS))
     return FALSE;
@@ -610,6 +638,9 @@
 {
   struct unit_type *p = get_unit_type(id);
 
+  free(p->effect);
+  p->effect = NULL;
+
   free(p->helptext);
   p->helptext = NULL;
 }
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/unittype.h freeciv-patched/common/unittype.h
--- freeciv-cvs/common/unittype.h	2003-06-30 12:18:28.000000000 +0100
+++ freeciv-patched/common/unittype.h	2003-06-30 12:18:17.000000000 +0100
@@ -20,6 +20,7 @@
 struct government;
 struct Sprite;			/* opaque; client-gui specific */
 struct unit;
+struct impr_effect;
 
 typedef int Unit_Type_id;
 /*
@@ -52,23 +53,10 @@
 */
 
 enum unit_move_type {
-  LAND_MOVING = 1, SEA_MOVING, HELI_MOVING, AIR_MOVING
+  LAND_MOVING = 1, SEA_MOVING, HELI_MOVING, AIR_MOVING, LAST_MOVING
 };
 
-/* Classes for unit types.
- * (These must correspond to unit_class_names[] in unit.c.)
- */
-enum unit_class_id {
-  UCL_AIR,
-  UCL_HELICOPTER,
-  UCL_LAND,
-  UCL_MISSILE,
-  UCL_NUCLEAR,
-  UCL_SEA,
-  UCL_LAST	/* keep this last */
-};
-
-typedef enum unit_class_id Unit_Class_id;
+typedef int Unit_Class_id;
 
 /* Unit "special effects" flags:
    Note this is now an enumerated type, and not power-of-two integers
@@ -148,6 +136,8 @@
 };
 #define L_MAX 64
 
+#define UCL_LAST (F_MAX + LAST_MOVING)
+
 BV_DEFINE(bv_flags, F_MAX);
 BV_DEFINE(bv_roles, L_MAX);
 struct unit_type {
@@ -187,9 +177,15 @@
   int paratroopers_mr_req;
   int paratroopers_mr_sub;
 
+  struct impr_effect *effect; /* list; .type==EFT_LAST terminated */
+
   char *helptext;
 };
 
+struct unit_classes {
+  enum unit_move_type move_type;
+  bv_flags flags;
+};
 
 extern struct unit_type unit_types[U_LAST];
 
@@ -205,12 +201,14 @@
 bool is_air_unittype(Unit_Type_id id);
 bool is_heli_unittype(Unit_Type_id id);
 bool is_ground_unittype(Unit_Type_id id);
+void get_unittype_classes(Unit_Type_id id, struct unit_classes *classes);
+bool is_unit_class_in_set(Unit_Class_id id, struct unit_classes *classes);
 
 int unit_value(Unit_Type_id id);
+int unit_value_adjusted(Unit_Type_id id, struct city *pcity);
 int unit_pop_value(Unit_Type_id id);
 
 const char *unit_name(Unit_Type_id id);
-const char *unit_class_name(Unit_Class_id id);
 
 const char *get_unit_name(Unit_Type_id id);
 const char *get_units_with_flag_string(int flag);
@@ -220,15 +218,15 @@
 int utype_happy_cost(struct unit_type *ut, struct government *g);
 int utype_gold_cost(struct unit_type *ut, struct government *g);
 
-int can_upgrade_unittype(struct player *pplayer, Unit_Type_id id);
+int can_upgrade_unittype(struct player *pplayer, Unit_Type_id id, bool leap);
 int unit_upgrade_price(const struct player * const pplayer,
 		       const Unit_Type_id from, const Unit_Type_id to);
 
 Unit_Type_id find_unit_type_by_name(const char *s);
 
 enum unit_move_type unit_move_type_from_str(const char *s);
-Unit_Class_id unit_class_from_str(const char *s);
 enum unit_flag_id unit_flag_from_str(const char *s);
+void unit_flag_set_name(enum unit_flag_id id, const char *s);
 enum unit_role_id unit_role_from_str(const char *s);
 
 bool can_player_build_unit_direct(struct player *p, Unit_Type_id id);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/data/civ1/buildings.ruleset freeciv-patched/data/civ1/buildings.ruleset
--- freeciv-cvs/data/civ1/buildings.ruleset	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/data/civ1/buildings.ruleset	2003-06-30 12:18:10.000000000 +0100
@@ -77,12 +77,9 @@
     }
 sound		= "b_aqueduct"
 sound_alt	= "b_generic"
-; FIXME: use this help text when gen-impr implemented...
-; /* (ignore for gettext until fixed)
-; helptext	= _("\
-; Allows a city to grow larger than size 10.\
-; ")
-; */
+helptext	= _("\
+Allows a city to grow larger than size 10.\
+")
 
 [building_bank]
 name		= _("Bank")
@@ -126,17 +123,9 @@
 upkeep		= 0
 sabotage	= 100
 effect		=
-    { "type", "range", "aff_unit"
-	"Unit_Veteran", "City", "Air"
-	"Unit_Repair", "City", "Air"
-	"Unit_Veteran", "City", "Helicopter"
-	"Unit_Repair", "City", "Helicopter"
-	"Unit_Veteran", "City", "Land"
-	"Unit_Repair", "City", "Land"
-	"Unit_Veteran", "City", "Missile"
-	"Unit_Repair", "City", "Missile"
-	"Unit_Veteran", "City", "Sea"
-	"Unit_Repair", "City", "Sea"
+    { "type", "range"
+	"Unit_Veteran", "City"
+	"Unit_Repair", "City"
     }
 variant		= 1		; FIXME: remove when gen-impr obsoletes
 sound		= "b_barracks_i"
@@ -164,17 +153,9 @@
 upkeep		= 1
 sabotage	= 100
 effect		=
-    { "type", "range", "aff_unit"
-	"Unit_Veteran", "City", "Air"
-	"Unit_Repair", "City", "Air"
-	"Unit_Veteran", "City", "Helicopter"
-	"Unit_Repair", "City", "Helicopter"
-	"Unit_Veteran", "City", "Land"
-	"Unit_Repair", "City", "Land"
-	"Unit_Veteran", "City", "Missile"
-	"Unit_Repair", "City", "Missile"
-	"Unit_Veteran", "City", "Sea"
-	"Unit_Repair", "City", "Sea"
+    { "type", "range"
+	"Unit_Veteran", "City"
+	"Unit_Repair", "City"
     }
 sound		= "b_barracks_ii"
 sound_alt	= "b_generic"
@@ -201,17 +182,9 @@
 upkeep		= 2
 sabotage	= 100
 effect		=
-    { "type", "range", "aff_unit"
-	"Unit_Veteran", "City", "Air"
-	"Unit_Repair", "City", "Air"
-	"Unit_Veteran", "City", "Helicopter"
-	"Unit_Repair", "City", "Helicopter"
-	"Unit_Veteran", "City", "Land"
-	"Unit_Repair", "City", "Land"
-	"Unit_Veteran", "City", "Missile"
-	"Unit_Repair", "City", "Missile"
-	"Unit_Veteran", "City", "Sea"
-	"Unit_Repair", "City", "Sea"
+    { "type", "range"
+	"Unit_Veteran", "City"
+	"Unit_Repair", "City"
     }
 sound		= "b_barracks_iii"
 sound_alt	= "b_generic"
@@ -264,7 +237,7 @@
 sabotage	= 100
 effect		=
     { "type", "range", "amount", "aff_unit"
-	"Unit_Defend", "City", 300, "Helicopter"
+	"Unit_Defend", "City", 300, "Heli"
 	"Unit_Defend", "City", 300, "Land"
 	"Unit_Defend", "City", 300, "Sea"
 	"Unit_No_Lose_Pop", "City", 0, "Land"
@@ -345,9 +318,9 @@
 sabotage	= 100
 effect		=
     { "type", "range", "amount", "cond_gov"
-	"Reduce_Corrupt", "City", 50
+	"Corrupt_Adj", "City", -50
 	"Make_Content", "City", 1, "Democracy"
-	"Revolt_Dist", "City", 50
+	"Revolt_Dist_Adj", "City", -50
     }
 sound		= "b_courthouse"
 sound_alt	= "b_generic"
@@ -454,8 +427,8 @@
 effect		=
     { "type", "range", "amount", "cond_bldg"
 	"Prod_Bonus", "City", 50, "Factory"
-	"Pollu_Adj_Prod", "City", 50
-	"Pollu_Adj_Prod", "City", -50, "Recycling Center"
+	"Pollu_Prod_Adj", "City", -50
+	"Pollu_Prod_Adj", "City", 50, "Recycling Center"
     }
 sound		= "b_hydro_plant"
 sound_alt	= "b_generic"
@@ -539,7 +512,7 @@
 sabotage	= 100
 effect		=
     { "type", "range", "amount"
-	"Pollu_Set_Pop", "City", 0
+	"Pollu_Pop_Pct", "City", 0
     }
 sound		= "b_mass_transit"
 sound_alt	= "b_generic"
@@ -592,8 +565,8 @@
 effect		=
     { "type", "range", "amount", "cond_bldg"
 	"Prod_Bonus", "City", 50, "Factory"
-	"Pollu_Adj_Prod", "City", 50
-	"Pollu_Adj_Prod", "City", -50, "Recycling Center"
+	"Pollu_Prod_Adj", "City", -50
+	"Pollu_Prod_Adj", "City", 50, "Recycling Center"
     }
 sound		= "b_nuclear_plant"
 sound_alt	= "b_generic"
@@ -773,7 +746,7 @@
 sabotage	= 100
 effect		=
     { "type", "range", "amount"
-	"Pollu_Adj_Prod", "City", 34
+	"Pollu_Prod_Adj", "City", -66
     }
 sound		= "b_recycling_center"
 sound_alt	= "b_generic"
@@ -907,7 +880,7 @@
 effect		=
     { "type", "range", "amount", "cond_bldg"
 	"Prod_Bonus", "City", 50, "Factory"
-	"Pollu_Set_Prod", "City", 0
+	"Pollu_Prod_Pct", "City", 0
 	"Slow_Global_Warm", "World", 10
     }
 sound		= "b_solar_plant"
@@ -1273,7 +1246,7 @@
 sabotage	= 0
 effect		=
     { "type", "range", "amount"
-	"Make_Happy", "Player", 1
+	"Force_Happy", "Player", 1
     }
 sound		= "w_cure_for_cancer"
 sound_alt	= "w_generic"
@@ -1405,8 +1378,8 @@
 sabotage	= 0
 effect		=
     { "type", "range", "amount"
-	"Make_Happy", "Player", 1
-	"Make_Happy", "City", 2
+	"Force_Happy", "Player", 1
+	"Force_Happy", "City", 2
     }
 sound		= "w_hanging_gardens"
 sound_alt	= "w_generic"
@@ -1435,8 +1408,8 @@
 effect		=
     { "type", "range", "amount", "cond_bldg"
 	"Prod_Bonus", "Island", 50, "Factory"
-	"Pollu_Adj_Prod", "Island", 50
-	"Pollu_Adj_Prod", "Island", -50, "Recycling Center"
+	"Pollu_Prod_Adj", "Island", -50
+	"Pollu_Prod_Adj", "Island", 50, "Recycling Center"
     }
 variant		= 1		; FIXME: remove when gen-impr obsoletes
 sound		= "w_hoover_dam"
@@ -1489,7 +1462,7 @@
 sabotage	= 0
 effect		=
     { "type", "range", "amount"
-	"Make_Content", "Island", 2
+	"Force_Content", "Island", 2
     }
 variant		= 1		; FIXME: remove when gen-impr obsoletes
 sound		= "w_js_bachs_cathedral"
@@ -1623,8 +1596,9 @@
     }
 sound		= "w_manhattan_project"
 sound_alt	= "w_generic"
-;helptext is set in client/helpdata.c:helptext_wonder()
-;helptext	=
+helptext	= _("\
+Allows all players with knowledge of Rocketry to build Nuclear units.\
+")
 
 [building_marco_polos_embassy]
 name		= _("Marco Polo's Embassy")
@@ -1769,7 +1743,7 @@
 sabotage	= 0
 effect		=
     { "type", "range", "amount"
-	"Make_Content", "City", 99
+	"Force_Content", "City", 99
     }
 sound		= "w_shakespeares_theatre"
 sound_alt	= "w_generic"
@@ -1819,9 +1793,9 @@
 upkeep		= 0
 sabotage	= 0
 effect		=
-    { "type", "range", "amount", "aff_unit"
+    { "type", "range", "amount", "aff_unit", "outside"
+	"Unit_Vet_Combat", "Player", 100, "Land", 1
 	"Unit_Veteran", "Player", 0, "Land"
-	"Unit_Vet_Combat", "Player", 100, "Land"
     }
 sound		= "w_sun_tzus_war_academy"
 sound_alt	= "w_generic"
@@ -1879,8 +1853,9 @@
 upkeep		= 0
 sabotage	= 0
 effect		=
-    { "type", "range", "amount"
-	"Make_Content_Mil", "Player", 1
+    { "type", "range", "amount", "cond_gov"
+	"Make_Content_Mil_Per", "Player", 1, "Republic"
+	"Make_Content_Mil_Per", "Player", 1, "Democracy"
     }
 variant		= 1		; FIXME: remove when gen-impr obsoletes
 sound		= "w_womens_suffrage"
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/data/civ1/governments.ruleset freeciv-patched/data/civ1/governments.ruleset
--- freeciv-cvs/data/civ1/governments.ruleset	2003-06-30 12:18:25.000000000 +0100
+++ freeciv-patched/data/civ1/governments.ruleset	2003-06-30 12:17:55.000000000 +0100
@@ -349,7 +349,7 @@
 tech_req    = "Communism"
 graphic     = "gov.communism"
 graphic_alt = "-"
-flags       = "Build_Veteran_Diplomats"
+flags       = "-"
 hints       = "Favors_Growth"
 subgoal	    = "Monarchy"
 
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/data/civ1/units.ruleset freeciv-patched/data/civ1/units.ruleset
--- freeciv-cvs/data/civ1/units.ruleset	2003-06-30 12:18:25.000000000 +0100
+++ freeciv-patched/data/civ1/units.ruleset	2003-06-30 12:17:55.000000000 +0100
@@ -14,6 +14,9 @@
 options="1.9"
 
 
+[userflags]
+names = "Horse"
+
 ; Below: The individual units, one per section.
 ;
 ; The number can be variable, up to 200.  
@@ -284,8 +287,15 @@
 uk_shield     = 1
 uk_food       = 0
 uk_gold       = 0
-flags         = "Pikemen"
+flags         = ""
 roles         = "DefendGood", "FirstBuild"
+effect        =
+    { "type", "amount", "aff_unit"
+        "Unit_Defend", 200, "Horse"
+    }
+helptext      = _("\
+Gets double defense against units specified as 'mounted'.\
+")
 
 [unit_musketeers]
 name          = _("Musketeers")
@@ -628,6 +638,9 @@
 uk_gold       = 0
 flags         = "Horse"
 roles         = "AttackFast"
+helptext      = _("\
+Counts as 'mounted' against certain defenders.\
+")
 
 [unit_knights]
 name          = _("Knights")
@@ -685,6 +698,9 @@
 uk_gold       = 0
 flags         = "Horse"
 roles         = "AttackFast", "BarbarianBuildTech", "BarbarianSeaTech"
+helptext      = _("\
+Counts as 'mounted' against certain defenders.\
+")
 
 [unit_civ2_cavalry]
 name          = "Civ2-Cavalry"  ; no i18n
@@ -1215,8 +1231,17 @@
 uk_shield     = 1
 uk_food       = 0
 uk_gold       = 0
-flags         = "AEGIS"
+flags         = ""
 roles         = ""
+effect        =
+    { "type", "amount", "aff_unit"
+        "Unit_Defend", 500, "Air"
+        "Unit_Defend", 500, "Heli"
+        "Unit_Defend", 500, "Missile"
+    }
+helptext      = _("\
+Gets quintuple defence against missiles, aeroplanes, and helicopters.\
+")
 
 [unit_battleship]
 name          = _("Battleship")
@@ -1441,6 +1466,10 @@
 uk_gold       = 0
 flags         = "Diplomat", "IgZOC", "NonMil"
 roles         = "Explorer"
+effect        =
+    { "type", "cond_gov"
+        "Unit_Veteran", "Communism"
+    }
 helptext      = _("\
 - A Diplomat can establish embassies with other civilizations\
  by moving into another player's city.\
@@ -1487,6 +1516,10 @@
 uk_gold       = 0
 flags         = "Diplomat", "IgZOC", "NonMil", "Spy"
 roles         = ""
+effect        =
+    { "type", "cond_gov"
+        "Unit_Veteran", "Communism"
+    }
 
 [unit_caravan]
 name          = _("Caravan")
